setwd("/spider_finna/DoubletFinder")
library(Seurat)
library(dplyr)
library(patchwork)
library(ggplot2)
library("Nebulosa")
library("Seurat")
library("BiocFileCache")
library("DoubletFinder")
#
data_dir <- "G:/spider_finna/Seurat/data"
list.files(data_dir)
pre_expression_matrix <- Read10X(data.dir = data_dir)
dim(pre_expression_matrix)                 
pre_expression_matrix[1:10,1:6]
#creat seurat project
#filter cell
pre <- CreateSeuratObject(counts = pre_expression_matrix, project = "Tc_Sg", min.cells = 3, min.features = 20)  

seurat_object <- pre
dim(pre)
#cell filter standard:median +- 2mad
nFeature_RNA_up <- median(seurat_object$nFeature_RNA) + 2*mad(seurat_object$nFeature_RNA)
nFeature_RNA_up
nFeature_RNA_low <- median(seurat_object$nFeature_RNA) - 2*mad(seurat_object$nFeature_RNA)
nFeature_RNA_low
nCount_RNA_up <- median(seurat_object$nCount_RNA) + 2*mad(seurat_object$nCount_RNA)
nCount_RNA_up
nCount_RNA_low <- median(seurat_object$nCount_RNA) - 2*mad(seurat_object$nCount_RNA)
nCount_RNA_low
seurat_object <- subset(seurat_object, subset = nFeature_RNA > nFeature_RNA_low & nFeature_RNA < nFeature_RNA_up & nCount_RNA > nCount_RNA_low & nCount_RNA < nCount_RNA_up)
dim(seurat_object)

VlnPlot(seurat_object, features = c("nFeature_RNA", "nCount_RNA", "percent.mt"), ncol = 3)
ggsave("plot2.pdf", width = 28, height = 25, units = "cm")

#DoubletFinder remove doublets
seurat_object <- SCTransform(seurat_object)
seurat_object <- RunPCA(seurat_object, verbose = F)
ElbowPlot(seurat_object)
pc.num=1:15
seurat_object <- RunUMAP(seurat_object, dims=pc.num)
seurat_object <- FindNeighbors(seurat_object, dims = pc.num) %>% FindClusters(resolution = 0.3)

## search pK value
sweep.res.list <- paramSweep_v3(seurat_object, PCs = pc.num, sct = T) #5min
sweep.stats <- summarizeSweep(sweep.res.list, GT = FALSE)
bcmvn <- find.pK(sweep.stats)
pK_bcmvn <- bcmvn$pK[which.max(bcmvn$BCmetric)] %>% as.character() %>% as.numeric()

## 
DoubletRate = ncol(seurat_object)*8*1e-6
homotypic.prop <- modelHomotypic(seurat_object$seurat_clusters) 
nExp_poi <- round(DoubletRate*ncol(seurat_object)) 
nExp_poi.adj <- round(nExp_poi*(1-homotypic.prop))

##
seurat_object <- doubletFinder_v3(seurat_object, PCs = pc.num, pN = 0.25, pK = pK_bcmvn, 
                                  nExp = nExp_poi.adj, reuse.pANN = F, sct = T)

table(seurat_object$DF.classifications_0.25_0.02_731)
DimPlot(seurat_object, reduction = "umap", group.by = "DF.classifications_0.25_0.02_731")
seurat_object <- subset(seurat_object, subset = DF.classifications_0.25_0.02_731 == "Singlet")
save(seurat_object,file = "obj.Rda")
